/*
 * Copyright (c) 2007, Going Dot Com Inc. All rights reserved.
 */

package jp.co.going.xbrl.taxonomy;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import jp.co.going.xbrl.common.XbException;

/**
 * @author Going Dot Com Inc.
 */
public class XbResourceItemDAO {

    // singleton作成
    private static XbResourceItemDAO singleton = null;
    // Connection変数
    private static Connection conn = null;
    // ステートメントを作成
    private PreparedStatement stmt = null;

    // コンストラクタ
    private XbResourceItemDAO() {
    }

    // インスタンス取得
    public static XbResourceItemDAO getInstance(Connection connection) {
        // インスタンスを生成
        if (singleton == null) {
            conn = connection;
            singleton = new XbResourceItemDAO();
        }

        return singleton;
    }

    protected int insert(XbResourceItemObj obj)
        throws XbException {

        try {
            StringBuffer  strb_sql = new StringBuffer();
            // 問合せの実行
            strb_sql.append("insert into ");
            strb_sql.append("xb_resource_item ");
            strb_sql.append("values ");
            strb_sql.append("(?, ?, ?, ?, ?, ?)");

            // SQL設定
            stmt = conn.prepareStatement(strb_sql.toString());

            int index = 1;
            stmt.setLong(index++, obj.getResource_item_id());
            stmt.setLong(index++, obj.getResource_id());
            stmt.setString(index++, obj.getNamespace());
            stmt.setString(index++, obj.getNamespace_url());
            stmt.setString(index++, obj.getItem_name());
            stmt.setString(index++, obj.getItem_value());

            // SQL　実行
            int count =stmt.executeUpdate();

            // ステートメントをクローズ
            stmt.close();

            return count;
        } catch (SQLException e) {
            throw new XbException(e, "SQLError : " + e.getMessage());
        }
    }
}
